Index: ip_icmp.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_icmp.c,v
retrieving revision 1.85
diff -u -p -r1.85 ip_icmp.c
--- ip_icmp.c	20 Nov 2003 20:07:37 -0000	1.85
+++ ip_icmp.c	5 Jan 2004 13:56:50 -0000
@@ -543,7 +543,11 @@ reflect:
 			       (int)(gw >> 24), (int)((gw >> 16) & 0xff),
 			       (int)((gw >> 8) & 0xff), (int)(gw & 0xff));
 		}
-		if (drop_redirect)
+		/*
+		 * RFC1812 says we must ignore ICMP redirects if we
+		 * are acting as router.
+		 */
+		if (drop_redirect || ipforwarding)
 			break;
 		if (code > 3)
 			goto badcode;
